//---------------------------------------------------------------------------
#ifndef AdvancedComH
#define AdvancedComH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "ComThread.h"
//---------------------------------------------------------------------------
typedef void __fastcall (__closure *TComStatEvent)( System::TObject* Sender, bool ctsOn, bool dsrOn, bool ringOn, bool rlsdOn);
//---------------------------------------------------------------------------
class PACKAGE TAdvancedCom : public TComThread
{
public:
	enum TDtrControl { dtrDisable=DTR_CONTROL_DISABLE, dtrEnable=DTR_CONTROL_ENABLE, dtrHandshake=DTR_CONTROL_HANDSHAKE	};
	enum TRtsControl { rtsDisable=RTS_CONTROL_DISABLE, rtsEnable=RTS_CONTROL_ENABLE, rtsHandshake=RTS_CONTROL_HANDSHAKE, rtsToggle=RTS_CONTROL_TOGGLE};
private:
	TDtrControl FDtrControl;
	TRtsControl FRtsControl;
	bool FDtr;
	bool FRts;
	TComStatEvent FOnStatusChanged;
//METHODS

protected:
	virtual void __fastcall SetDtrControl( TDtrControl d);
	virtual void __fastcall SetRtsControl( TRtsControl r);
	virtual void __fastcall SetDtr( bool d);
	virtual void __fastcall SetRts( bool r);
  virtual void SetupThread();
  virtual void SetupState();

public:
  __fastcall TAdvancedCom(TComponent* Owner);
	__property bool Dtr = {read=FDtr, write=SetDtr};
	__property bool Rts = {read=FRts, write=SetRts};

__published:
	__property TDtrControl DtrControl = {read=FDtrControl, write=SetDtrControl, default=dtrEnable};
	__property TRtsControl RtsControl = {read=FRtsControl, write=SetRtsControl, default=rtsToggle};
	__property TComStatEvent OnStatusChanged ={read=FOnStatusChanged, write=FOnStatusChanged};
};
//---------------------------------------------------------------------------
#endif
